// Written by TeTeT for CH-46

ttt_ch46_fnc_rescue = {
	params ["_unit"];

	private _spawnPos = _unit getPos [200, random 360];
	_spawnPos set [2, 50];
	private _ret = [_spawnPos, _spawnPos getDir _unit, "ttt_ch46d", side _unit] call BIS_fnc_spawnVehicle;
	_ret params ["_helo", "_crew", "_grp"];

	private _wp = _grp addWaypoint [_unit, 0];
	_wp setWaypointType "HOOK";
	_wp setWaypointCompletionRadius 0;
	_helo flyInHeight 10;
	_helo flyInHeightASL [10,10,10];

	/**
	[_helo, _unit] spawn {
		params ["_helo", "_unit"];

		while {alive _helo and alive _unit and _helo distance _unit > 5} do {
			systemChat str (_helo distance _unit);
			sleep 1;
		};
	};
	**/

	waitUntil {_helo distance2D _unit < 10};
	systemChat "Starting rescue";
	_grp call 
	{
		for "_i" from count waypoints _this - 1 to 0 step -1 do 
		{
			deleteWaypoint [_this, _i];
		};
	};
	_helo flyInHeight 10;
	_helo flyInHeightASL [10,10,10];
	while {_helo distance _unit > 100} do {
		systemChat "Rope not long enough, waiting for helo to move closer";
		sleep 5;
	};
	[_helo] call ttt_ch46_fnc_basketDeploy;
	private _rope = _helo getVariable "ttt_basketRope";
	ropeUnwind [_rope, 3, _helo distance _unit];
	private _basket = _helo getVariable "ttt_basket";
	waitUntil {_unit in _basket;};
	ropeUnwind [_rope, 3, -1 * (_helo distance _unit)];
	waitUntil { _unit distance _helo < 7};
	[_helo] call ttt_ch46_fnc_basketRecover;
	// no idea why the above does not move the unit in the helo
	_unit moveInCargo _helo;

	systemChat "Rescue complete";
	systemChat "Land via map click";
	_unit;
};


ttt_ch46_fnc_mapClick = {
	params ["_pos"];
	if (isNull objectParent player) then {
		player setPos _pos;
	} else {
		private _helo = objectParent player;
		// systemChat str typeOf _helo;
		private _wp = (group driver _helo) addWaypoint [_pos, 0];
		_wp setWaypointType "GETOUT";
	};
};

[] spawn {
	sleep 1;
	onMapSingleClick "[_pos] call ttt_ch46_fnc_mapClick";
	player addAction [
		"Call rescue helicopter",
		"[player] call ttt_ch46_fnc_rescue",
		nil,
		5,
		false,
		true,
		"",
		"isNull objectParent _this"
	];
	systemChat "Teleport via map click";
}
